SystemOrganization addCategory: #'PacMan-DDispatch-Barroumeres-Laje'!

TestCase subclass: #PacManTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan-DDispatch-Barroumeres-Laje'!

!PacManTest methodsFor: 'actors' stamp: 'MarianoB 5/20/2012 21:51'!
blueGhost

	^Ghost new.! !

!PacManTest methodsFor: 'actors' stamp: 'MarianoB 5/20/2012 21:51'!
blueberry

	^Blueberry new.! !

!PacManTest methodsFor: 'movements' stamp: 'MarianoB 5/20/2012 21:55'!
down

	^DownDirection new.! !

!PacManTest methodsFor: 'construction block types' stamp: 'MarianoB 5/20/2012 21:51'!
ghostHouseDoorType

	^GhostDoorTile new.! !

!PacManTest methodsFor: 'movements' stamp: 'MarianoB 5/20/2012 21:55'!
left

	^LeftDirection new.! !

!PacManTest methodsFor: 'construction block types' stamp: 'MarianoB 5/20/2012 21:51'!
leftTransporterType

	^TransporterTile new.! !

!PacManTest methodsFor: 'actors' stamp: 'MarianoB 5/20/2012 21:52'!
pacman

	^Pacman new.! !

!PacManTest methodsFor: 'movements' stamp: 'MarianoB 5/20/2012 21:55'!
right

	^RightDirection new.! !

!PacManTest methodsFor: 'construction block types' stamp: 'MarianoB 5/20/2012 21:52'!
spaceType

	^SpaceTile new.
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test01GhostCanNotGoIntoAWall

	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self left ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self right ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self up ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test02PacmanCanNotGoIntoAWall

	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self left ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self right ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self up ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:38'!
test02aFruitCanNotGoIntoAWall

	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self left ).
	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self right ).
	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self up ).
	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test03GhostMovesIntoSpaces

	self assert: ( self blueGhost position + (-1@0) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self left ).
	self assert: ( self blueGhost position +  (1@0) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self right ).
	self assert: ( self blueGhost position +  (0@1) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self up ).
	self assert: ( self blueGhost position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test04PacmanMovesIntoSpaces

	self assert: ( self pacman position + (-1@0) ) equals: ( self spaceType nextPositionFor: self pacman going: self left ).
	self assert: ( self pacman position +  (1@0) ) equals: ( self spaceType nextPositionFor: self pacman going: self right ).
	self assert: ( self pacman position +  (0@1) ) equals: ( self spaceType nextPositionFor: self pacman going: self up ).
	self assert: ( self pacman position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self pacman going: self down ).

! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:39'!
test04aFruitMovesIntoSpaces

	self assert: ( self blueberry position + (-1@0) ) equals: ( self spaceType nextPositionFor: self blueberry going: self left ).
	self assert: ( self blueberry position +  (1@0) ) equals: ( self spaceType nextPositionFor: self blueberry going: self right ).
	self assert: ( self blueberry position +  (0@1) ) equals: ( self spaceType nextPositionFor: self blueberry going: self up ).
	self assert: ( self blueberry position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self blueberry going: self down ).

! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test05GhostCanEnterHisHouse

	self assert: ( self blueGhost position + (-1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self left).
	self assert: ( self blueGhost position +  (1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self right ).
	self assert: ( self blueGhost position +  (0@1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self up ).
	self assert: ( self blueGhost position + (0@ -1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test06PacmanCanNotEnterGhostHouse

	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self left ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self right ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self up ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:40'!
test06aFruitCanEnterHisHouse

	self assert: ( self blueberry position + (-1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self left).
	self assert: ( self blueberry position +  (1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self right ).
	self assert: ( self blueberry position +  (0@1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self up ).
	self assert: ( self blueberry position + (0@ -1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test07GhostCanNotGoIntoTransporter

	self assert: self blueGhost position equals: ( self leftTransporterType nextPositionFor: self blueGhost going: self left ).
	self assert: self blueGhost position equals: ( self leftTransporterType nextPositionFor: self blueGhost going: self right ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test08TransporterMovesPacmanToNewPosition

	self assert: (3@10) equals: ( self leftTransporterType nextPositionFor: self pacman going: self left ).
	self assert: (3@10) equals: ( self leftTransporterType nextPositionFor: self pacman going: self right ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:46'!
test09TransporterMovesFruitToNewPosition

	self assert: (5@10) equals: ( self leftTransporterType nextPositionFor: self blueberry going: self left ).
	self assert: (5@10) equals: ( self leftTransporterType nextPositionFor: self blueberry going: self right ).
! !

!PacManTest methodsFor: 'movements' stamp: 'MarianoB 5/20/2012 21:54'!
up

	^UpDirection new.! !

!PacManTest methodsFor: 'construction block types' stamp: 'MarianoB 5/20/2012 21:52'!
wallType

	^WallTile new.! !

Object subclass: #Actor
	instanceVariableNames: 'position'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan-DDispatch-Barroumeres-Laje'!

!Actor methodsFor: 'as yet unclassified' stamp: 'MarianoB 5/20/2012 23:19'!
initialize

	position := 0@0
	
! !

!Actor methodsFor: 'as yet unclassified' stamp: 'MarianoB 5/20/2012 22:13'!
nextPositionWhenFacing: aTile towards: aDirection

	^self subclassResponsibility .
	! !

!Actor methodsFor: 'as yet unclassified' stamp: 'MarianoB 5/20/2012 21:56'!
position



	^position.
	! !

Actor subclass: #Blueberry
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan-DDispatch-Barroumeres-Laje'!

!Blueberry methodsFor: 'as yet unclassified' stamp: 'MarianoB 5/20/2012 22:15'!
nextPositionWhenFacing: aTile towards: aDirection


	^aTile nextBlueberryPositionFor: self going: aDirection.! !

Actor subclass: #Ghost
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan-DDispatch-Barroumeres-Laje'!

!Ghost methodsFor: 'as yet unclassified' stamp: 'MarianoB 5/20/2012 22:16'!
nextPositionWhenFacing: aTile towards: aDirection


	^aTile nextGhostPositionFor: self going: aDirection.! !

Actor subclass: #Pacman
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan-DDispatch-Barroumeres-Laje'!

!Pacman methodsFor: 'as yet unclassified' stamp: 'MarianoB 5/20/2012 22:16'!
nextPositionWhenFacing: aTile towards: aDirection


	^aTile nextPacmanPositionFor: self going: aDirection.! !

Object subclass: #Direction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan-DDispatch-Barroumeres-Laje'!

!Direction methodsFor: 'as yet unclassified' stamp: 'MarianoB 5/20/2012 22:23'!
nextPositionFrom: aPosition

	^self subclassResponsibility .! !

Direction subclass: #DownDirection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan-DDispatch-Barroumeres-Laje'!

!DownDirection methodsFor: 'as yet unclassified' stamp: 'MarianoB 5/20/2012 23:20'!
nextPositionFrom: aPosition

	^ aPosition + ( 0@ -1)! !

Direction subclass: #LeftDirection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan-DDispatch-Barroumeres-Laje'!

!LeftDirection methodsFor: 'as yet unclassified' stamp: 'MarianoB 5/20/2012 23:20'!
nextPositionFrom: aPosition 

	^ aPosition + (-1@0)! !

Direction subclass: #RightDirection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan-DDispatch-Barroumeres-Laje'!

!RightDirection methodsFor: 'as yet unclassified' stamp: 'MarianoB 5/20/2012 23:20'!
nextPositionFrom: aPosition 

	^ aPosition + (1@0).! !

Direction subclass: #UpDirection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan-DDispatch-Barroumeres-Laje'!

!UpDirection methodsFor: 'as yet unclassified' stamp: 'MarianoB 5/20/2012 23:21'!
nextPositionFrom: aPosition 

	^ aPosition + (0@1)! !

Object subclass: #Tile
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan-DDispatch-Barroumeres-Laje'!

Tile subclass: #GhostDoorTile
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan-DDispatch-Barroumeres-Laje'!

!GhostDoorTile methodsFor: 'as yet unclassified' stamp: 'MarianoB 5/20/2012 23:56'!
nextBlueberryPositionFor: aBlueberry going: aDirection


	"A nuestro criterio, la solucion correcta para nosotros seria
	algo del estilo : 	
		^aBlueberry position nextPositionWhenMoving: aDirection.
	Dejando la responsabilidad a una Posicion como evoluciona dependiendo de la direccion de movimiento.
	Como en los tests esa hardcodeado que una position es un point, delegamos la responsabilidad a la direccion, pero solo 
	porque hacerlo aqui seria ademas forzar a aDirection a comportarse tambien como un Punto, lo que es claramente inconveniente
	"

	^aDirection nextPositionFrom: aBlueberry position.! !

!GhostDoorTile methodsFor: 'as yet unclassified' stamp: 'MarianoB 5/20/2012 23:56'!
nextGhostPositionFor: aGhost going: aDirection

	"A nuestro criterio, la solucion correcta para nosotros seria
	algo del estilo : 	
	^aGhost position nextPositionWhenMoving: aDirection. 
	Dejando la responsabilidad a una Posicion como evoluciona dependiendo de la direccion de movimiento.
	Como en los tests esa hardcodeado que una position es un point, delegamos la responsabilidad a la direccion, pero solo 
	porque hacerlo aqui seria ademas forzar a aDirection a comportarse tambien como un Punto, lo que es claramente inconveniente
	"
	
	^aDirection nextPositionFrom: aGhost position.
	
! !

!GhostDoorTile methodsFor: 'as yet unclassified' stamp: 'MarianoB 5/20/2012 22:21'!
nextPacmanPositionFor: aPacman going: aDirection

	^aPacman position.! !

Tile subclass: #SpaceTile
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan-DDispatch-Barroumeres-Laje'!

!SpaceTile methodsFor: 'as yet unclassified' stamp: 'MarianoB 5/20/2012 23:56'!
nextBlueberryPositionFor: aBlueberry going: aDirection


	"A nuestro criterio, la solucion correcta para nosotros seria
	algo del estilo : 	
		^aBlueberry position nextPositionWhenMoving: aDirection.
	Dejando la responsabilidad a una Posicion como evoluciona dependiendo de la direccion de movimiento.
	Como en los tests esa hardcodeado que una position es un point, delegamos la responsabilidad a la direccion, pero solo 
	porque hacerlo aqui seria ademas forzar a aDirection a comportarse tambien como un Punto, lo que es claramente inconveniente
	"
	
	^aDirection nextPositionFrom: aBlueberry position.


! !

!SpaceTile methodsFor: 'as yet unclassified' stamp: 'MarianoB 5/20/2012 23:56'!
nextGhostPositionFor: aGhost going: aDirection


	"A nuestro criterio, la solucion correcta para nosotros seria
	algo del estilo : 	
		^aGhost position nextPositionWhenMoving: aDirection.
	Dejando la responsabilidad a una Posicion como evoluciona dependiendo de la direccion de movimiento.
	Como en los tests esa hardcodeado que una position es un point, delegamos la responsabilidad a la direccion, pero solo 
	porque hacerlo aqui seria ademas forzar a aDirection a comportarse tambien como un Punto, lo que es claramente inconveniente
	"
	
	^aDirection nextPositionFrom: aGhost position.




	! !

!SpaceTile methodsFor: 'as yet unclassified' stamp: 'MarianoB 5/20/2012 23:57'!
nextPacmanPositionFor: aPacman going: aDirection



	"A nuestro criterio, la solucion correcta para nosotros seria
	algo del estilo : 	
		^aPacman position nextPositionWhenMoving: aDirection.
	Dejando la responsabilidad a una Posicion como evoluciona dependiendo de la direccion de movimiento.
	Como en los tests esa hardcodeado que una position es un point, delegamos la responsabilidad a la direccion, pero solo 
	porque hacerlo aqui seria ademas forzar a aDirection a comportarse tambien como un Punto, lo que es claramente inconveniente
	"
	
	^aDirection nextPositionFrom: aPacman position.



! !

!Tile methodsFor: 'as yet unclassified' stamp: 'MarianoB 5/20/2012 22:14'!
nextPositionFor: anActor going: aDirection

	^anActor nextPositionWhenFacing: self towards: aDirection.
! !

Tile subclass: #TransporterTile
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan-DDispatch-Barroumeres-Laje'!

!TransporterTile methodsFor: 'as yet unclassified' stamp: 'MarianoB 5/20/2012 22:20'!
nextBlueberryPositionFor: aBlueBerry going: aDirection

	^ 5@10! !

!TransporterTile methodsFor: 'as yet unclassified' stamp: 'MarianoB 5/20/2012 22:21'!
nextGhostPositionFor: aGhost going: aDirection


	^aGhost position.! !

!TransporterTile methodsFor: 'as yet unclassified' stamp: 'MarianoB 5/20/2012 22:21'!
nextPacmanPositionFor: aPacman going: aDirection

	
^ 3@10! !

Tile subclass: #WallTile
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan-DDispatch-Barroumeres-Laje'!

!WallTile methodsFor: 'as yet unclassified' stamp: 'MarianoB 5/20/2012 22:19'!
nextBlueberryPositionFor: aBlueberry going: aDirection

	^aBlueberry position.! !

!WallTile methodsFor: 'as yet unclassified' stamp: 'MarianoB 5/20/2012 22:19'!
nextGhostPositionFor: aGhost going: aDirection

	^aGhost position.! !

!WallTile methodsFor: 'as yet unclassified' stamp: 'MarianoB 5/20/2012 22:18'!
nextPacmanPositionFor: aPacman going: aDirection

	^aPacman position.! !
